//======================================================================
// 
// Cacheman IOCTL definition file
//
// Copyright (C) 1997 Bryce Cogswell and Mark Russinovich
//
//======================================================================

//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//
#define FILE_DEVICE_CACHEMAN     0x00008343


//
// Commands that the GUI can send the device driver
//
enum {
    CACHEMAN_GET 
    = CTL_CODE( FILE_DEVICE_CACHEMAN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS  ),
    CACHEMAN_SET
    = CTL_CODE( FILE_DEVICE_CACHEMAN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS  ),
};



//
// Data structure passed between the GUI and the driver
//
struct cacheman_getset {
    ULONG		CcDirtyPageThreshold;
    ULONG		CcDirtyPageTarget;
    ULONG		CcMaxDirtyWrite;
    ULONG		CcAvailablePagesThreshold;

    LARGE_INTEGER	CcFirstDelay;
    LARGE_INTEGER	CcIdleDelay;
    LARGE_INTEGER	CcCollisionDelay;
    LARGE_INTEGER	CcTargetCleanDelay;

    ULONG		MmSystemCacheWsMinimum;
    ULONG		MmSystemCacheWsMaximum;

    ULONG		MmWorkingSetReductionMaxCacheWs;
    ULONG		MmWorkingSetReductionMinCacheWs;
    ULONG		MmWorkingSetVolReductionMaxCacheWs;

    ULONG		MiDoPeriodicAgressiveTrimming;
    ULONG		MmPeriodicAgressiveTrimMinFree;
    ULONG		MmPeriodicAgressiveTrimMaxFree;
    ULONG		MmPeriodicAgressiveCacheWsMin;
};

